package com.sf.vertx.handle;

import io.vertx.core.json.JsonObject;
import io.vertx.ext.web.RoutingContext;
import io.vertx.ext.web.handler.HttpException;

public class RestfulFailureHandlerImpl implements RestfulFailureHandler {

	@Override
	public void handle(RoutingContext frc) {
		Throwable failure = frc.failure();
		if (failure instanceof HttpException) {
			HttpException httpException = (HttpException) failure;
			// frc.response().setStatusCode(404).end();
			JsonObject dataJson = new JsonObject(httpException.getPayload());
			frc.response().setChunked(true).setStatusCode(httpException.getStatusCode())
					.putHeader("Content-Type", "application/json").end(dataJson.toBuffer());
			return;
		}
		frc.response().setStatusCode(500).setStatusMessage("Server internal error:" + failure.getMessage()).end();
	}

}
